//+------------------------------------------------------------------+
//|                                                neuro-example.mq5 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
#include <Trade\Trade.mqh>        //     
#include <Trade\PositionInfo.mqh> //      

//---     
//---  RSI
input double w0=0.5;
input double w1=0.5;
input double w2=0.5;
input double w3=0.5;
input double w4=0.5;
input double w5=0.5;
input double w6=0.5;
input double w7=0.5;
input double w8=0.5;
input double w9=0.5;

//---  StdDev
input double w10=0.5;
input double w11=0.5;
input double w12=0.5;
input double w13=0.5;
input double w14=0.5;
input double w15=0.5;
input double w16=0.5;
input double w17=0.5;
input double w18=0.5;
input double w19=0.5;

//---     
//---  RSI
input double w20=0.5;
input double w21=0.5;
input double w22=0.5;
input double w23=0.5;
input double w24=0.5;
input double w25=0.5;
input double w26=0.5;
input double w27=0.5;
input double w28=0.5;
input double w29=0.5;

//---  StdDev
input double w30=0.5;
input double w31=0.5;
input double w32=0.5;
input double w33=0.5;
input double w34=0.5;
input double w35=0.5;
input double w36=0.5;
input double w37=0.5;
input double w38=0.5;
input double w39=0.5;

//---     
//---  RSI
input double w40=0.5;
input double w41=0.5;
input double w42=0.5;
input double w43=0.5;
input double w44=0.5;
input double w45=0.5;
input double w46=0.5;
input double w47=0.5;
input double w48=0.5;
input double w49=0.5;

//---  StdDev
input double w50=0.5;
input double w51=0.5;
input double w52=0.5;
input double w53=0.5;
input double w54=0.5;
input double w55=0.5;
input double w56=0.5;
input double w57=0.5;
input double w58=0.5;
input double w59=0.5;

//---     
input double w60=0.5;
input double w61=0.5;
input double w62=0.5;


input double perrsi=14;
input double perstddev=14;
//---  

input double sum=0.5;
input double shift1=0.5;
input double shift2=0.5;

int               iRSI_handle;  //     
int               iStdDev_handle;

double            iRSI_buf[];   //      
double            iStdDev_buf[];

double            inputs[20];   //     
double            inputs2[3];

double            weight11[20];   //     
double            weight12[20];
double            weight13[20];
double            weight21[20];

double            out;
double            out11;          //      
double            out12;
double            out13;
double            out21;

double            PerRSI;
double            PerStdDev;

double            SUM;
double            SHIFT1;
double            SHIFT2;

string            my_symbol;    //    
ENUM_TIMEFRAMES   my_timeframe; //    
double            lot_size;     //       

CTrade            m_Trade;      //     
CPositionInfo     m_Position;   //      
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
//---            
   my_symbol=Symbol();
//---            
   my_timeframe=PERIOD_CURRENT;
//---     
   lot_size=SymbolInfoDouble(my_symbol,SYMBOL_VOLUME_MIN);
//---      
   PerRSI = perrsi;
   PerStdDev = perstddev;
   iRSI_handle=iRSI(my_symbol,my_timeframe,PerRSI,PRICE_CLOSE);
   iStdDev_handle=iStdDev(my_symbol,my_timeframe,PerStdDev,0,MODE_EMA,PRICE_CLOSE);
   
//---    
   if(iRSI_handle==INVALID_HANDLE||iStdDev_handle==INVALID_HANDLE)
     {
      //---   ,      ,    
      Print("    ");
      return(-1);
     }
//---     
   ChartIndicatorAdd(ChartID(),0,iRSI_handle);
   ChartIndicatorAdd(ChartID(),1,iStdDev_handle);
//---     iRSI_buf   
   ArraySetAsSeries(iRSI_buf,true);
   ArraySetAsSeries(iStdDev_buf,true);
//---     
//---  
   weight11[0]=w0;
   weight11[1]=w1;
   weight11[2]=w2;
   weight11[3]=w3;
   weight11[4]=w4;
   weight11[5]=w5;
   weight11[6]=w6;
   weight11[7]=w7;
   weight11[8]=w8;
   weight11[9]=w9;
   
   weight11[10]=w10;
   weight11[11]=w11;
   weight11[12]=w12;
   weight11[13]=w13;
   weight11[14]=w14;
   weight11[15]=w15;
   weight11[16]=w16;
   weight11[17]=w17;
   weight11[18]=w18;
   weight11[19]=w19;
   
   weight12[0]=w20;
   weight12[1]=w21;
   weight12[2]=w22;
   weight12[3]=w23;
   weight12[4]=w24;
   weight12[5]=w25;
   weight12[6]=w26;
   weight12[7]=w27;
   weight12[8]=w28;
   weight12[9]=w29;
   
   weight12[10]=w30;
   weight12[11]=w31;
   weight12[12]=w32;
   weight12[13]=w33;
   weight12[14]=w34;
   weight12[15]=w35;
   weight12[16]=w36;
   weight12[17]=w37;
   weight12[18]=w38;
   weight12[19]=w39;
   
   weight13[0]=w40;
   weight13[1]=w41;
   weight13[2]=w42;
   weight13[3]=w43;
   weight13[4]=w44;
   weight13[5]=w45;
   weight13[6]=w46;
   weight13[7]=w47;
   weight13[8]=w48;
   weight13[9]=w49;
   
   weight13[10]=w50;
   weight13[11]=w51;
   weight13[12]=w52;
   weight13[13]=w53;
   weight13[14]=w54;
   weight13[15]=w55;
   weight13[16]=w56;
   weight13[17]=w57;
   weight13[18]=w58;
   weight13[19]=w59;
   
//---  

   weight21[0]=w60;
   weight21[1]=w61;
   weight21[2]=w62;
   
   SUM = sum;
   SHIFT1 = shift1;
   SHIFT2 = shift2;
//---  0,  
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---        
   IndicatorRelease(iRSI_handle);
   IndicatorRelease(iStdDev_handle);
//---    iRSI_buf  
   ArrayFree(iRSI_buf);
   ArrayFree(iStdDev_buf);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---        
   int err1=0;
   int err2=0;
//---         iRSI_buf     
   err1=CopyBuffer(iRSI_handle,0,1,10,iRSI_buf);
   err2=CopyBuffer(iStdDev_handle,0,1,10,iStdDev_buf);
//---   ,           
   if(err1<0)
     {
      Print("        RSI14");
      return;
     }
   if(err2<0)
     {
      Print("        RSI28");
      return;
     }
//---
   /*double d1=0.0;                                 //     
   double d2=1.0;                                 //     
   double x_min=iRSI_buf[ArrayMinimum(iRSI_buf)]; //   
   double x_max=iRSI_buf[ArrayMaximum(iRSI_buf)]; //   
   
   double x_min28=iRSI28_buf[ArrayMinimum(iRSI28_buf)]; //   
   double x_max28=iRSI28_buf[ArrayMaximum(iRSI28_buf)]; //   */

//---          
   for(int i=0;i<ArraySize(inputs);i++)
     {
     if(i<10){
        inputs[i]=iRSI_buf[i];
     }else{
        inputs[i]=iStdDev_buf[i-10];
     }
         //inputs[i]=iRSI_buf[i];
     }
//---       out
   out11=CalculateNeuron(inputs,weight11);
   out12=CalculateNeuron(inputs,weight12);
   out13=CalculateNeuron(inputs,weight13);
   
   inputs2[0]=out11;
   inputs2[1]=out12;
   inputs2[2]=out13;
   
   out=CalculateNeuronOUT(inputs2,weight21);
   
//---      0.5
   if(out<0.5)
     {
      //---       
      if(m_Position.Select(my_symbol))
        {
         //---     Sell,   
         if(m_Position.PositionType()==POSITION_TYPE_SELL) m_Trade.PositionClose(my_symbol);
         //---      Buy,  
         if(m_Position.PositionType()==POSITION_TYPE_BUY) return;
        }
      //---   ,   ,  
      m_Trade.Buy(lot_size,my_symbol);
     }
//---        0.5
   if(out>=0.5)
     {
      //---       
      if(m_Position.Select(my_symbol))
        {
         //---     Buy,   
         if(m_Position.PositionType()==POSITION_TYPE_BUY) m_Trade.PositionClose(my_symbol);
         //---      Sell,  
         if(m_Position.PositionType()==POSITION_TYPE_SELL) return;
        }
      //---   ,   ,  
      m_Trade.Sell(lot_size,my_symbol);
     }
  }
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
double CalculateNeuron(double &x[],double &w[])
  {
//---       
   double NET=0.0;
//---         
   for(int n=0;n<ArraySize(x);n++)
     {
      NET+=x[n]*w[n];
     }
   NET-=SHIFT1;
//---       
   NET*=SUM;
//---           
   return(ActivateNeuron(NET));
  }
double CalculateNeuronOUT(double &x[],double &w[])
  {
//---       
   double NET=0.0;
//---         
   for(int n=0;n<ArraySize(x);n++)
     {
      NET+=x[n]*w[n];
     }
   NET-=SHIFT2;
//---       
   NET*=SUM;
//---           
   return(ActivateNeuron(NET));
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
double ActivateNeuron(double x)
  {
//---      
   double Out;
//--- 
   Out=1/(1+exp(-x));
//---    
   return(Out);
  }
//+------------------------------------------------------------------+
